=== debian/changelog ===
libcgns (3.1.3.4-1) unstable; urgency=low

  * New upstream release
  * Manpages (finally) added

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 24 Jan 2012 11:33:35 +0100

libcgns (3.1.3.2-2) unstable; urgency=low

  * Upload in unstable

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 18 Jan 2012 20:28:02 +0100

libcgns (2.5.5-3) unstable; urgency=low

  * Change HDF5 dependency from libhdf5-serial-dev => libhdf5-dev
  * Rebuild against hdf5 1.8.8
  * return.diff: Fix a new FTBFS (control reaches end of non-void function)
  * Get ride of the patch wrongProfile.diff (managed now by HDF)

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 18 Jan 2012 19:07:18 +0100
