=== debian/watch ===
version=3
http://sf.net/cgns/cgnslib_(.*)-(\d+)\.tar\.gz debian debian/orig-tar.sh
